%% This is file `bdrvntu.cls', based on `extreport.cls' 
%% generated by Ovchinnikov Konstantin,
%%              Vinnytsia National Technical University, Ukraine.
%%
%%              Harmonized with DSTU 3008-95
%%              by Konstantin Ovchinnikov.
%%              ovkos1980@gmail.com % 
%% 
%% The original source files were:
%% Copyright 1993 1994 1995 1996 1999
%% The LaTeX3 Project and any individual authors listed elsewhere 
%% in this file. 
%% 
%% This file may be distributed under the terms of the Latex Project
%% public licence
%% 
%% This system is distributed in the hope that it will be useful, 
%% but WITHOUT ANY WARRANTY; without even the implied warranty of 
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{bdrvntu}[08.02.2022 v1.0 Non Standard LaTeX class]

\LoadClass[14pt]{extreport}
\RequirePackage{cmap}
\RequirePackage[utf8]{inputenc}
\RequirePackage[T2A,T1]{fontenc}
\RequirePackage[english,russian,ukrainian]{babel}
\RequirePackage[a4paper,left=3cm,top=2.0cm,bottom=2.5cm,right=1.5cm,layoutvoffset=0.5cm]{geometry}
\RequirePackage{eso-pic}%
\RequirePackage{tikz}%
\RequirePackage[absolute,overlay]{textpos}%
\RequirePackage{cite}%
\RequirePackage[hidelinks,breaklinks,hypertexnames=false]{hyperref}%
\RequirePackage{xurl}%            for url's hyphenation
\RequirePackage[normalem]{ulem}%  \uline
\RequirePackage{soulutf8}%        \ul base for \longunderline command 
\RequirePackage{tabto}%
\RequirePackage{longtable}%
\RequirePackage{multirow}%
\RequirePackage{pdfpages}%
\RequirePackage{xcntperchap}%
\RequirePackage{totcount}% 
\RequirePackage{amssymb}%

\DeclareOption*{\PassOptionsToClass{\CurrentOption}{extreport}}
\ProcessOptions\relax


%% total counters delaration need "totcount" package
%% use \total{figures} command for typesetting total number of figures in document
%% use \total{tables} command for typesetting total number of tables in document
%% use \total{citnum} command for typesetting total number of bibitem in bibliography list
%% use \total{page} command for typesetting total number of pages in document
\newtotcounter{figures}\setcounter{figures}{0}
\newtotcounter{tables}\setcounter{tables}{0}
\newtotcounter{citnum}
 \def\oldbibitem{} \let\oldbibitem=\bibitem
 \def\bibitem{\stepcounter{citnum}\oldbibitem}
\regtotcounter{page}


%% long cyrillic underline delaration need "tabto" package
\setul{0.666ex}{0.52pt}% set \ul underline depth and thickness 
\newcommand{\longunderline}[1]{\ul{#1}\tabto{\CurrentLineWidth}\rule[-.75ex]{\dimexpr\linewidth-\TabPrevPos\relax}{0.52pt}}
\renewcommand{\ULthickness}{0.52pt}% set \uline thickness 
\setlength{\arrayrulewidth}{0.52pt}% make thickness of rules in tables the same as underline 

\newif\if@mainmatter
\newcommand\mainmatter{\@mainmattertrue\setcounter{page}{2}}
\newcommand\frontmatter{\@mainmatterfalse}
\newcommand\aftermatter{\@mainmatterfalse}

\newif\if@latexmark
\newcommand\latexmarkon{\@latexmarktrue}
\newcommand\latexmarkoff{\@latexmarkfalse}

\AtBeginDocument{\mainmatter%
                 \latexmarkon%        let the LaTeX mark on first page of TOC appears
                 \oneandhalfspace}%   set onehalf space

\newcommand{\underonespace}{\linespread{0.8}\selectfont}
\newcommand{\onespace}{\linespread{1}\selectfont}
\newcommand{\oneandhalfspace}{\linespread{1.36}\selectfont}

\setlength{\parindent}{2.5em}
\newlength\floatindent                   %for able to place tables with paragraph indentation
\setlength{\floatindent}{\parindent}

\renewcommand{\@evenhead}{\hfill\thepage}
\renewcommand{\@oddhead}{\hfill\thepage}
\renewcommand{\@evenfoot}{}
\renewcommand{\@oddfoot}{}

                    
%common names definitions
\newcommand\educational[1]{\renewcommand\@educational{#1}}
\newcommand\@educational{Вінницький національний технічний університет} 
\newcommand\educationalabbr[1]{\renewcommand\@educationalabbr{#1}}
\newcommand\@educationalabbr{ВНТУ}
\newcommand\faculty[1]{\renewcommand\@faculty{#1}}
\newcommand\@faculty{інтелектуальних інформаційних технологій та автоматизації}
\newcommand\facultyabbr[1]{\renewcommand\@facultyabbr{#1}}
\newcommand\@facultyabbr{IITA}
\newcommand\department[1]{\renewcommand\@department{#1}}
\newcommand\@department{автоматизації та інтелектуальних інформаційних технологій}
\newcommand\departmentabbr[1]{\renewcommand\@departmentabbr{#1}}
\newcommand\@departmentabbr{АІІТ}
\newcommand\rdepartmentabbr[1]{\renewcommand\@rdepartmentabbr{#1}}
\newcommand\@rdepartmentabbr{\textbackslash rdepartmentabbr}
\newcommand\departmentcode[1]{\renewcommand\@departmentcode{#1}}
\newcommand\@departmentcode{08-31}
\newcommand\typeofwork[1]{\renewcommand\@typeofwork{#1}}            %type of work
\newcommand\@typeofwork{Бакалаврська кваліфікаційна робота}         %вид роботи
\newcommand\acstypeofwork[1]{\renewcommand\@acstypeofwork{#1}}      %type of work (accusative)
\newcommand\@acstypeofwork{бакалаврську кваліфікаційну роботу}      %вид роботи в знахідному відмінку 
\newcommand\classcode[1]{\renewcommand\@classcode{#1}}
\newcommand\@classcode{КР}
\newcommand\optioncode[1]{\renewcommand\@optioncode{#1}}
\newcommand\@optioncode{000}
\newcommand\discipline[1]{\renewcommand\@discipline{#1}}
\newcommand\@discipline{\textbackslash discipline}
\renewcommand\title[1]{\renewcommand\@title{#1}}
\renewcommand\@title{\textbackslash title}
\newcommand\parttitle[1]{\renewcommand\@parttitle{#1}}
\newcommand\@parttitle{\@title}
\newcommand\partdes[1]{\renewcommand\@partdes{#1}}
\newcommand\@partdes{Пояснювальна записка}
\newcommand\partcode[1]{\renewcommand\@partcode{#1}}
\newcommand\@partcode{ПЗ}
\newcommand\course[1]{\renewcommand\@course{#1}}
\newcommand\@course{\textbackslash course}
\newcommand\group[1]{\renewcommand\@group{#1}}
\newcommand\@group{\textbackslash group}
\newcommand\direction[1]{\renewcommand\@direction{#1}}
\newcommand\@direction{\textbackslash direction}
\newcommand\speciality[1]{\renewcommand\@speciality{#1}}
\newcommand\@speciality{\textbackslash speciality}
\newcommand\branchofknowledge[1]{\renewcommand\@branchofknowledge{#1}}
\newcommand\@branchofknowledge{\textbackslash branchofknowledge}
\newcommand\educationalprogram[1]{\renewcommand\@educationalprogram{#1}}
\newcommand\@educationalprogram{\textbackslash educationalprogram}
\renewcommand\author[1]{\renewcommand\@author{#1}}
\renewcommand\@author{\textbackslash author}
\newcommand\authorgender[1]{\renewcommand\@authorgender{#1}}
\newcommand\@authorgender{}
\newcommand\gcauthor[1]{\renewcommand\@gcauthor{#1}}      %genitive case of author
\newcommand\@gcauthor{\textbackslash gcauthor}
\newcommand\reviewerdegree[1]{\renewcommand\@rdegree{#1}}
\newcommand\@rdegree{\textbackslash rdegree}
\newcommand\degree[1]{\renewcommand\@degree{#1}}
\newcommand\@degree{\textbackslash degree}
\newcommand\position[1]{\renewcommand\@position{#1}}
\newcommand\@position{\textbackslash position}
\newcommand\reviewerposition[1]{\renewcommand\@rposition{#1}}
\newcommand\@rposition{\textbackslash rposition}
\newcommand\leader[1]{\renewcommand\@leader{#1}}
\newcommand\@leader{\textbackslash leader}
\newcommand\city[1]{\renewcommand\@city{#1}}
\newcommand\@city{Вінниця}
\newcommand\annum[1]{\renewcommand\@annum{#1}}
\newcommand\@annum{\the\year}
\newcommand\developer[1]{\renewcommand\@developer{#1}}
\newcommand\@developer{\@author}
\newcommand\supervisor[1]{\renewcommand\@supervisor{#1}}
\newcommand\@supervisor{\@leader}
\newcommand\reviewer[1]{\renewcommand\@reviewer{#1}}
\newcommand\@reviewer{\textbackslash reviewer}
\newcommand\controller[1]{\renewcommand\@controller{#1}}
\newcommand\@controller{\textbackslash controller}
\newcommand\approver[1]{\renewcommand\@approver{#1}}
\newcommand\@approver{\textbackslash approver}
\newcommand\dpheaderstatus[1]{\renewcommand\@dpheaderstatus{#1}}
\newcommand\@dpheaderstatus{Завідувач кафедри}

\newcommand\acode[1]{\renewcommand\@acode{#1}}
\newcommand\@acode{\textbackslash acode}
\newcommand\bcode[1]{\renewcommand\@bcode{#1}}
\newcommand\@bcode{\textbackslash bcode}
\newcommand\ccode[1]{\renewcommand\@ccode{#1}}
\newcommand\@ccode{\textbackslash ccode}
\newcommand\dcode[1]{\renewcommand\@dcode{#1}}
\newcommand\@dcode{\textbackslash dcode}
\newcommand\ecode[1]{\renewcommand\@ecode{#1}}
\newcommand\@ecode{\textbackslash ecode}
\newcommand\fcode[1]{\renewcommand\@fcode{#1}}
\newcommand\@fcode{\textbackslash fсode}
\newcommand\designation[7]{\ifx&#1&\else\acode{#1}\fi%
                           \ifx&#2&\else\bcode{#2}\fi%
                           \ifx&#3&\else\ccode{#3}\fi%
                           \ifx&#4&\else\dcode{#4}\fi%
                           \ifx&#5&\else\ecode{#5}\fi%
                           \ifx&#6&\else\fcode{#6}\fi%
                           \ifx&#7&\else\partdes{#7}\fi}
\newcommand\@designation{\@acode.\@bcode.\@ccode.\@dcode.\@ecode~\@fcode}

%redefinition common names defined in ukraine babel package
\addto\captionsukrainian{%
  \def\abstractname{Анотація}%
  \def\prefacename{Вступ}%
  \def\refname{Література}%
  \def\bibname{Список використаних джерел}%
  \def\chaptername{Розділ}%
  \def\appendixname{Додаток}%
  \def\appendixtitle{Додатки}%
  \def\contentsname{Зміст}%
  \def\listfigurename{Перелік ілюстрацій}%
  \def\listtablename{Перелік таблиць}%
  \def\indexname{Покажчик}%
  \def\authorname{Іменний покажчик}%
  \def\figurename{Рисунок}%
  \def\tablename{Таблиця}%
  \def\partname{Частина}%
  \def\enclname{вкладка}%
  \def\ccname{копія}%
  \def\headtoname{До}%
  \def\pagename{с.}%
  \def\seename{див.}%
  \def\alsoname{див. також}
  \def\proofname{Доведення}%
  \def\glossaryname{Словник термінів}}

%cyrillic symbols for list and appendix mark use (only allowed symbols acording DSTU 3008-95)
\newcommand*{\Abetka}[1]{\@Abetka{\@nameuse{c@#1}}}
\newcommand*{\@Abetka}[1]%
{\ifcase #1\or {А}\or {Б}\or {В}\or {Г}\or {Д}\or {Е}\or {Ж}\or {И}\or {К}\or {Л}\or {М}\or {Н}\or
               {П}\or {Р}\or {С}\or {Т}\or {У}\or {Ф}\or {Х}\or {Ц}\or {Ш}\or {Щ}\or {Ю}\or {Я}\else\@ctrerr \fi}
\newcommand*{\abetka}[1]{\@abetka{\@nameuse{c@#1}}}
\newcommand*{\@abetka}[1]%
{\ifcase #1\or {а}\or {б}\or {в}\or {г}\or {д}\or {е}\or {ж}\or {и}\or {к}\or {л}\or {м}\or {н}\or 
               {п}\or {р}\or {с}\or {т}\or {у}\or {ф}\or {х}\or {ц}\or {ш}\or {щ}\or {ю}\or {я}\else\@ctrerr \fi}


\g@addto@macro\normalsize{
\setlength\abovedisplayskip{20\p@ plus 3\p@ minus 1\p@} % было: 8 + 2 - 4
\setlength\belowdisplayskip{20\p@ plus 3\p@ minus 1\p@} % было: 8 + 2 - 4
\setlength\abovedisplayshortskip{0\p@ plus 3\p@ minus 0\p@}
\setlength\belowdisplayshortskip{20\p@ plus 3\p@ minus 1\p@}
}

\renewcommand{\labelitemi}{--~}
\renewcommand{\labelitemii}{--~}
\renewcommand{\labelitemiii}{--~}
\renewcommand{\labelenumi}{\@abetka\theenumi)}
\renewcommand{\labelenumii}{\arabic{enumii})}
\renewcommand{\labelenumiii}{\Roman{enumiii})}

\renewcommand{\@listI}{%
              \leftmargin=\parindent
              \addtolength{\leftmargin}{1.5em}
              \rightmargin=0\p@
              \labelsep=0.5em
              \labelwidth=0\p@ 
              \itemindent=0em
              \listparindent=0pt
              \topsep=0\p@ plus 2\p@ minus 4\p@
              \partopsep=0\p@ plus 1\p@ minus 1\p@ 
              \parsep=0\p@ plus 1\p@
              \itemsep=\parsep}
\def\@listii {\leftmargin\leftmarginii
              \labelwidth\leftmarginii
              \advance\labelwidth-\labelsep
              \topsep  0\p@ \@plus 3\p@ \@minus \p@
              \parsep  0\p@ \@plus  \p@ \@minus \p@
              \itemsep \parsep}
\def\@listiii{\leftmargin\leftmarginiii
              \labelwidth\leftmarginiii
              \advance\labelwidth-\labelsep
              \topsep  0\p@ \@plus  \p@ \@minus \p@
              \parsep  \z@
              \partopsep \p@\@plus  \z@ \@minus \p@
              \itemsep \topsep}


\IfFileExists{t2aiso.fd}                                                               %if iso font installed
   {\newcommand*{\gostfnt}{\fontencoding{T2A}\fontfamily{iso}\selectfont\slshape}}     %set iso font
   {\newcommand*{\gostfnt}{\sffamily\slshape}}                                         %else set sff famyly fon. No "\selectfont" needed here


%% blueprints frames definitions -------------------------------------------------------------------------
%% drawings frames ---------------------------------------------------------------------------------------
\def\x@offset{0.0}
\def\y@offset{0.0}
\newdimen\thick
\newdimen\thin
\thick=0.55mm
\thin=0.2mm

\newcounter{tcnt}%total page counter
\newcounter{ccnt}%current page counter    
\newcounter{fcnt}%first page counter
%\RegisterTrackCounter{tcnt}{page}        % unknown issue with this comand in overleaf.com while compiling. Commented for now  

%\newcounter{apxccnt}%appendix current page counter    
%\newtotcounter{apxfcnt}%appendix first page counter
%\newtotcounter{apxtcnt}%appendix total page counter

\newif\if@designhm\@designhmtrue% if designation in horizontal mode
\newcommand\designhm{\@designhmtrue}
\newcommand\designvm{\@designhmfalse}

\newcommand\raw@border{% raw border
\draw[black, line width=\thick] (2.0,0.5) rectangle (20.5+\x@offset,29.2+\y@offset);
}

\newcommand\raw@form@I{% primary stamp according to form 1
\draw[black, line width=\thick] ( 2.0+\x@offset,0.5) rectangle (20.5+\x@offset,6.0);
\draw[black, line width=\thick] ( 2.7+\x@offset,3.5) -- ( 2.7+\x@offset,6.0);
\draw[black, line width=\thick] ( 3.7+\x@offset,0.5) -- ( 3.7+\x@offset,6.0);
\draw[black, line width=\thick] ( 6.0+\x@offset,0.5) -- ( 6.0+\x@offset,6.0);
\draw[black, line width=\thick] ( 7.5+\x@offset,0.5) -- ( 7.5+\x@offset,6.0);
\draw[black, line width=\thick] ( 8.5+\x@offset,0.5) -- ( 8.5+\x@offset,6.0);
\draw[black, line width=\thick] (15.5+\x@offset,0.5) -- (15.5+\x@offset,4.5);
\draw[black, line width=\thick] (17.0+\x@offset,2.5) -- (17.0+\x@offset,4.5);
\draw[black, line width=\thick] (17.5+\x@offset,2.0) -- (17.5+\x@offset,2.5);
\draw[black, line width=\thick] (18.7+\x@offset,2.5) -- (18.7+\x@offset,4.5);
\draw[black, line width=\thick] ( 2.0+\x@offset,3.5) -- ( 8.5+\x@offset,3.5);
\draw[black, line width=\thick] ( 2.0+\x@offset,4.0) -- ( 8.5+\x@offset,4.0);
\draw[black, line width=\thick] ( 8.5+\x@offset,2.0) -- (20.5+\x@offset,2.0);
\draw[black, line width=\thick] (15.5+\x@offset,2.5) -- (20.5+\x@offset,2.5);
\draw[black, line width=\thick] (15.5+\x@offset,4.0) -- (20.5+\x@offset,4.0);
\draw[black, line width=\thick] ( 8.5+\x@offset,4.5) -- (20.5+\x@offset,4.5);
\draw[black, line width=\thin ] (16.0+\x@offset,2.5) -- (16.0+\x@offset,4.0);
\draw[black, line width=\thin ] (16.5+\x@offset,2.5) -- (16.5+\x@offset,4.0);
\draw[black, line width=\thin ] (17.0+\x@offset,2.5) -- (17.0+\x@offset,4.0);
\draw[black, line width=\thin ] ( 2.0+\x@offset,1.0) -- ( 8.5+\x@offset,1.0);
\draw[black, line width=\thin ] ( 2.0+\x@offset,1.5) -- ( 8.5+\x@offset,1.5);
\draw[black, line width=\thin ] ( 2.0+\x@offset,2.0) -- ( 8.5+\x@offset,2.0);
\draw[black, line width=\thin ] ( 2.0+\x@offset,2.5) -- ( 8.5+\x@offset,2.5);
\draw[black, line width=\thin ] ( 2.0+\x@offset,3.0) -- ( 8.5+\x@offset,3.0);
\draw[black, line width=\thin ] ( 2.0+\x@offset,4.5) -- ( 8.5+\x@offset,4.5);
\draw[black, line width=\thin ] ( 2.0+\x@offset,5.0) -- ( 8.5+\x@offset,5.0);
\draw[black, line width=\thin ] ( 2.0+\x@offset,5.5) -- ( 8.5+\x@offset,5.5);
\gostfnt
\draw ( 2.35+\x@offset,3.75) node        {\footnotesize {Зм.}};
\draw ( 3.20+\x@offset,3.71) node        {\footnotesize {Арк.}};
\draw ( 1.90+\x@offset,3.21) node[right] {\footnotesize {Розроб.}};
\draw ( 1.90+\x@offset,2.71) node[right] {\footnotesize {Пров.}};
\draw ( 1.90+\x@offset,2.21) node[right] {\footnotesize {T. контр.}};
\draw ( 1.90+\x@offset,1.71) node[right] {\footnotesize {Реценз.}};
\draw ( 1.90+\x@offset,1.21) node[right] {\footnotesize {Н. контр.}};
\draw ( 1.90+\x@offset,0.71) node[right] {\footnotesize {Затверд.}};

\draw ( 3.60+\x@offset,3.21) node[right] {\footnotesize \@developer};
\draw ( 3.60+\x@offset,2.71) node[right] {\footnotesize \@supervisor};
\draw ( 3.60+\x@offset,1.71) node[right] {\footnotesize \@reviewer};
\draw ( 3.60+\x@offset,1.21) node[right] {\footnotesize \@controller};
\draw ( 3.60+\x@offset,0.71) node[right] {\footnotesize \@approver};

\draw ( 4.90+\x@offset,3.71) node        {\footnotesize {\textnumero~докум.}};
\draw ( 6.70+\x@offset,3.71) node        {\footnotesize {Підпис}};
\draw ( 8.00+\x@offset,3.71) node        {\footnotesize {Дата}};
\draw (16.25+\x@offset,4.21) node        {\footnotesize {Літера}};
\draw (17.80+\x@offset,4.25) node        {\footnotesize {Маса}};
\draw (19.50+\x@offset,4.25) node        {\footnotesize {Маштаб}};
%\draw (16.50+\x@offset,2.21) node       {\footnotesize {Аркуш}~\thepage};
%\draw (19.00+\x@offset,2.21) node       {\footnotesize {Аркушів}};

%\draw (14.50+\x@offset,5.25) node[fill=red!20]        {\Large{\@departmentcode.\@classcode.\@optioncode.\textbackslash xcode.\textbackslash xcode \@partcode}};
\draw (14.50+\x@offset,5.25) node        {\Large{\@designation}};
\draw (18.00+\x@offset,1.25) node        {\@educationalabbr, {гр.} \@group};
\underonespace
\draw (12.00+\x@offset,3.25) node[align=center,text width=6.8cm] {\small{\@parttitle\\ \@partdes}};
\oneandhalfspace
}

\newcommand\raw@form@II{% primary stamp according to form 2
\draw[black, line width=\thick] (2.0+\x@offset,0.5) rectangle (20.5+\x@offset,4.5);
\draw[black, line width=\thick] ( 2.0+\x@offset,4.5) -- (20.5+\x@offset,4.5);
\draw[black, line width=\thick] ( 2.0+\x@offset,3.0) -- (20.5+\x@offset,3.0);
\draw[black, line width=\thick] ( 3.7+\x@offset,0.5) -- ( 3.7+\x@offset,4.5);
\draw[black, line width=\thick] ( 6.0+\x@offset,0.5) -- ( 6.0+\x@offset,4.5);
\draw[black, line width=\thick] ( 7.5+\x@offset,0.5) -- ( 7.5+\x@offset,4.5);
\draw[black, line width=\thick] ( 8.5+\x@offset,0.5) -- ( 8.5+\x@offset,4.5);
\draw[black, line width=\thick] (15.5+\x@offset,0.5) -- (15.5+\x@offset,3.0);
\draw[black, line width=\thick] ( 2.7+\x@offset,3.0) -- ( 2.7+\x@offset,4.5);
%\draw[black, line width=\thick] (5.0+\x@offset,3.0) -- ( 5.0+\x@offset,4.5);
\draw[black, line width=\thick] ( 2.0+\x@offset,3.5) -- ( 8.5+\x@offset,3.5);
\draw[black, line width=\thick] (15.5+\x@offset,2.0) -- (20.5+\x@offset,2.0);
\draw[black, line width=\thick] (15.5+\x@offset,2.5) -- (20.5+\x@offset,2.5);
\draw[black, line width=\thick] (17.0+\x@offset,2.0) -- (17.0+\x@offset,3.0);
\draw[black, line width=\thick] (18.5+\x@offset,2.0) -- (18.5+\x@offset,3.0);
\draw[black, line width=\thin ] ( 2.0+\x@offset,1.0) -- ( 8.5+\x@offset,1.0);
\draw[black, line width=\thin ] ( 2.0+\x@offset,1.5) -- ( 8.5+\x@offset,1.5);
\draw[black, line width=\thin ] ( 2.0+\x@offset,2.0) -- ( 8.5+\x@offset,2.0);
\draw[black, line width=\thin ] ( 2.0+\x@offset,2.5) -- ( 8.5+\x@offset,2.5);
\draw[black, line width=\thin ] ( 2.0+\x@offset,4.0) -- ( 8.5+\x@offset,4.0);
\draw[black, line width=\thin ] (16.0+\x@offset,2.0) -- (16.0+\x@offset,2.5);
\draw[black, line width=\thin ] (16.5+\x@offset,2.0) -- (16.5+\x@offset,2.5);
\gostfnt
\draw ( 2.35+\x@offset,3.25) node        {\footnotesize {Зм.}};
\draw ( 3.20+\x@offset,3.21) node        {\footnotesize {Арк.}};
\draw ( 1.90+\x@offset,2.71) node[right] {\footnotesize {Розроб.}};
\draw ( 1.90+\x@offset,2.21) node[right] {\footnotesize {Пров.}};
\draw ( 1.90+\x@offset,1.71) node[right] {\footnotesize {Реценз.}};
\draw ( 1.90+\x@offset,1.21) node[right] {\footnotesize {Н. контр.}};
\draw ( 1.90+\x@offset,0.71) node[right] {\footnotesize {Затверд.}};

\draw ( 3.60+\x@offset,2.71) node[right] {\footnotesize \@developer};
\draw ( 3.60+\x@offset,2.21) node[right] {\footnotesize \@supervisor};
\draw ( 3.60+\x@offset,1.71) node[right] {\footnotesize \@reviewer};
\draw ( 3.60+\x@offset,1.21) node[right] {\footnotesize \@controller};
\draw ( 3.60+\x@offset,0.71) node[right] {\footnotesize \@approver};

\draw ( 4.90+\x@offset,3.21) node        {\footnotesize {\textnumero~докум.}};
\draw ( 6.70+\x@offset,3.21) node        {\footnotesize {Підпис}};
\draw ( 8.00+\x@offset,3.21) node        {\footnotesize {Дата}};
\draw (16.25+\x@offset,2.71) node        {\footnotesize {Літера}};
%\draw (16.25+\x@offset,2.21) node       {\footnotesize {Н}};
\draw (17.80+\x@offset,2.71) node        {\footnotesize {Аркуш}};
\draw (19.50+\x@offset,2.71) node        {\footnotesize {Аркушів}};
%\draw (17.80+\x@offset,2.21) node        {\footnotesize \thepage};
%\draw (19.50+\x@offset,2.21) node        {\footnotesize \pageref{LastPage}};
%\draw (14.50+\x@offset,3.70) node[fill=red!20]        {\Large{\@departmentcode.\@classcode.\@optioncode.00.000 \@partcode}};
\draw (14.50+\x@offset,3.70) node        {\Large{\@designation}};
\draw (18.00+\x@offset,1.25) node        {\@educationalabbr, {гр.} \@group};
\underonespace
\draw (12.00+\x@offset,1.71) node[align=center,text width=6.8cm] {\small{\@parttitle\\ \@partdes}};
\oneandhalfspace
}

\newcommand\raw@form@IIa{% primary stamp according to form 2a
\draw[black, line width=\thick] ( 2.0+\x@offset,0.5) rectangle (20.5+\x@offset,2.0);
\draw[black, line width=\thick] ( 8.5+\x@offset,0.5) -- ( 8.5+\x@offset,2.0);
\draw[black, line width=\thick] (19.5+\x@offset,0.5) -- (19.5+\x@offset,2.0);
\draw[black, line width=\thick] ( 2.7+\x@offset,0.5) -- ( 2.7+\x@offset,2.0);
\draw[black, line width=\thick] ( 3.7+\x@offset,0.5) -- ( 3.7+\x@offset,2.0);
\draw[black, line width=\thick] ( 6.0+\x@offset,0.5) -- ( 6.0+\x@offset,2.0);
\draw[black, line width=\thick] ( 7.5+\x@offset,0.5) -- ( 7.5+\x@offset,2.0);
\draw[black, line width=\thick] (19.5+\x@offset,1.3) -- (20.5+\x@offset,1.3);
\draw[black, line width=\thin ] ( 2.0+\x@offset,1.5) -- ( 8.5+\x@offset,1.5);
\draw[black, line width=\thick] ( 2.0+\x@offset,1.0) -- ( 8.5+\x@offset,1.0);
\gostfnt
\draw (20.00+\x@offset, 1.6 ) node {\footnotesize {Арк.}};
\draw ( 2.35+\x@offset, 0.75) node {\footnotesize {Зм.}};
\draw ( 3.20+\x@offset, 0.72) node {\footnotesize {Арк.}};
\draw ( 4.90+\x@offset, 0.72) node {\footnotesize {\textnumero~докум.}};
\draw ( 6.70+\x@offset, 0.72) node {\footnotesize {Підпис}};
\draw ( 8.00+\x@offset, 0.72) node {\footnotesize {Дата}};
%\draw (20.00+\x@offset, 0.9 ) node {\thepage};
%\draw (14.00+\x@offset, 1.2 ) node[fill=red!20] {\Large{\@departmentcode.\@classcode.\@optioncode.00.000 \@partcode}};
\draw (14.00+\x@offset, 1.2 ) node {\Large{\@designation}};
}

\newcommand\raw@form@I@pagenum{% form 1 page numbers
\setcounter{ccnt}{\value{page}}%
  \addtocounter{ccnt}{-\value{fcnt}}%
  \addtocounter{ccnt}{1}% ccnt = \value{page}-\value{apxfcnt}+1
  \ifapx@environment
    \draw (19.00+\x@offset,2.25) node[align=center,text width=4.5cm] {{\footnotesize Аркушів~\ObtainTrackedValueExp{tcnt}{page}}};
    \draw (16.50+\x@offset,2.25) node[align=center,text width=4.5cm] {{\footnotesize Аркуш~\arabic{ccnt}}};
  \else%
  \fi 
}

\newcommand\raw@form@II@pagenum{% form 2 page numbers
  \setcounter{ccnt}{\value{page}}%
  \addtocounter{ccnt}{-\value{fcnt}}%
  \addtocounter{ccnt}{1}% ccnt = \value{page}-\value{apxfcnt}+1
  \ifapx@environment
    \draw (19.50+\x@offset,2.25) node[align=center,text width=4.5cm] {\ObtainTrackedValueExp{tcnt}{page}};
    \draw (17.75+\x@offset,2.25) node[align=center,text width=4.5cm] {\arabic{ccnt}};
  \else%
  \fi 
}

\newcommand\raw@form@IIa@pagenum{% form 2a page numbers
  \setcounter{ccnt}{\value{page}}
  \addtocounter{ccnt}{-\value{fcnt}}
  \addtocounter{ccnt}{1}
  \ifapx@environment
    \draw (20.00+\x@offset, 0.9) node[align=center,text width=4.5cm] {\arabic{ccnt}};
  \else%
  \fi 
}

\newcommand\raw@design@h{% horizontal auxiliary designation
\draw[black, line width=\thick] (2.0,27.8+\y@offset) rectangle (9.0,29.2+\y@offset);
\gostfnt
%\draw (5.55, 28.5+\y@offset) node[rotate=180] {\large{\@departmentcode.\@classcode.\@optioncode.00.000 \@partcode}};
\draw (5.55, 28.5+\y@offset) node[rotate=180] {\large{\@designation}};
}

\newcommand\raw@design@v{% vertical auxiliary designation
\draw[black, line width=\thick] (19.1+\x@offset,22.2+\y@offset) rectangle (20.5+\x@offset,29.2+\y@offset);
\gostfnt
%\draw (19.8+\x@offset, 25.65+\y@offset) node[rotate=90] {\large{\@departmentcode.\@classcode.\@optioncode.00.000 \@partcode}};
\draw (19.8+\x@offset, 25.65+\y@offset) node[rotate=90] {\large{\@designation}};
}

\newcommand\raw@sheet@first{
\draw[black, line width=\thick] ( 4.0,4.5) -- ( 4.0,29.2);
\draw[black, line width=\thick] (15.0,4.5) -- (15.0,29.2);
\draw[black, line width=\thick] (16.0,4.5) -- (16.0,29.2);
\draw[black, line width=\thick] (2.0,4.5+.8*29) -- (20.5,4.5+.8*29);
\foreach \y in {1,...,28}{%
\draw[black, line width=\thick] (2.0,4.5+.8*\y) -- (20.5, 4.5+.8*\y);}
\underonespace
\draw ( 3.00,28.45) node[align=center,text width=2cm]  {Поз.\\ познач.};
\draw ( 9.50,28.45) node[align=center,text width=11cm] {Найменування};
\draw (15.50,28.45) node[align=center,text width=1.5cm,rotate=90] {Кільк.};
\draw (18.25,28.45) node[align=center,text width=4.5cm]{Примітка};
}

\newcommand\raw@sheet@after{
\draw[black, line width=\thick] ( 4.0,2.0) -- ( 4.0,29.2);
\draw[black, line width=\thick] (15.0,2.0) -- (15.0,29.2);
\draw[black, line width=\thick] (16.0,2.0) -- (16.0,29.2);
\draw[black, line width=\thick] (2.0, 2.1+.8*32) -- (20.5, 2.1+.8*32);
\foreach \y in {1,...,31}{%
\draw[black, line width=\thick] (2.0, 2.1+.8*\y) -- (20.5, 2.1+.8*\y);}
\underonespace
\draw ( 3.00,28.45) node[align=center,text width=2cm]  {Поз.\\ познач.};
\draw ( 9.50,28.45) node[align=center,text width=11cm] {Найменування};
\draw (15.50,28.45) node[align=center,text width=1.5cm,rotate=90] {Кільк.};
\draw (18.25,28.45) node[align=center,text width=4.5cm]{Примітка};
}

\@namedef{form@1}{\begin{tikzpicture}[overlay]
                  \raw@border
                  \raw@form@I
                  \if@designhm\raw@design@h\else\raw@design@v\fi
                  \raw@form@I@pagenum  
                  \end{tikzpicture}}
\@namedef{form@2}{\begin{tikzpicture}[overlay]
                  \raw@border
                  \raw@form@II
                  \if@designhm\raw@design@h\else\raw@design@v\fi
                  \raw@form@II@pagenum
                  \end{tikzpicture}}
\@namedef{form@2a}{\begin{tikzpicture}[overlay]
                   \raw@border
                   \raw@form@IIa
                   \if@designhm\raw@design@h\else\raw@design@v\fi
                   \raw@form@IIa@pagenum  
                   \end{tikzpicture}}                  
\def\form#1{\expandafter\ifx\csname form@#1\endcsname\relax
\expandafter\@gobble\else
\csname form@#1\expandafter\endcsname
\fi}

\@namedef{sheet@first}{\begin{tikzpicture}[overlay]
                       \raw@border% draw raw border
                       \raw@form@II% draw stamp form 2 
                       \raw@sheet@first% draw net
                       \raw@form@II@pagenum% type page numbers
                       \end{tikzpicture}}
\@namedef{sheet@after}{\begin{tikzpicture}[overlay]
                       \raw@border
                       \raw@form@IIa
                       \raw@sheet@after
                       \raw@form@IIa@pagenum
                       \end{tikzpicture}}                      
\def\sheet#1{\expandafter\ifx\csname sheet@#1\endcsname\relax
\expandafter\@gobble\else
\csname sheet@#1\expandafter\endcsname
\fi}

\newcommand{\lline}[4]{\centering #1 & #2 & \makebox[8mm]{#3} & #4 \tabularnewline}%
  
\newcommand{\element}[4]{\lline{#1}{#2}{#3}{#4}}
  
\newcommand{\category}[1]{\lline{}{\makebox[108mm]{#1}}{}{}}%

%% end drawing frames ------------------------------------------------------------------------------------------
%%--------------------------------------------------------------------------------------------------------------


\newcommand{\appheadinhibit}{\let\@makechapterhead\relax}
\newcommand{\pgbreakinhibit}{\vspace{50pt}\let\clearpage\relax}


\newenvironment{a3paperl}[1]
{
\clearpage
\advance\textwidth\pdfpagewidth
\pdfpagewidth=2\pdfpagewidth
\hsize=\textwidth
\linewidth=\hsize
\columnwidth=\hsize
\def\x@offset{21.0}
#1}
{\clearpage \pdfpagewidth=\paperwidth \pdfpageheight=\paperheight \ClearShipoutPicture}

\newenvironment{a3paperp}[1]
{
\clearpage
\advance\textwidth 87mm
%\pdfpagewidth = 297mm \paperwidth = \pdfpagewidth
\pdfpageheight = 420mm \paperheight = \pdfpageheight
\hsize=\textwidth
\linewidth=\hsize
\columnwidth=\hsize
\def\x@offset{8.7}
\def\y@offset{12.3}
#1}
{\clearpage \pdfpagewidth=210mm \pdfpageheight=297mm \ClearShipoutPicture}





%define \paper{} command for different formats of paper
\@namedef{paper@A4}{\clearpage%
                \pdfpagewidth = 210mm \paperwidth = \pdfpagewidth% set page weight
                \pdfpageheight = 297mm \paperheight = \pdfpageheight% set page height
                \textwidth = \dimexpr \pdfpagewidth - \Gm@lmargin - \Gm@rmargin% set new textwidth 
                \hsize=\textwidth% refresh other dimentions
                \linewidth=\hsize% refresh other dimentions
                \columnwidth=\hsize% refresh other dimentions
                \def\x@offset{0.0}% x@offset = pagewidth-210mm (for frame draw need)
                \def\y@offset{0.0}% y@offset = pageheight-297mm (for frame draw need)
                \designhm}
\@namedef{paper@A3}{\clearpage%
                \pdfpagewidth = 420mm \paperwidth = \pdfpagewidth
                \pdfpageheight = 297mm \paperheight = \pdfpageheight
                \textwidth = \dimexpr \pdfpagewidth - \Gm@lmargin - \Gm@rmargin
                \hsize=\textwidth%
                \linewidth=\hsize%
                \columnwidth=\hsize%
                \def\x@offset{21.0}
                \def\y@offset{0.0}
                \designhm}
\@namedef{paper@A3p}{\clearpage
                \pdfpagewidth = 297mm \paperwidth = \pdfpagewidth
                \pdfpageheight = 420mm \paperheight = \pdfpageheight
                \textwidth = \dimexpr \pdfpagewidth - \Gm@lmargin - \Gm@rmargin
                \hsize=\textwidth
                \linewidth=\hsize
                \columnwidth=\hsize
                \def\x@offset{8.7}
                \def\y@offset{12.3}
                \designvm}
\@namedef{paper@A2}{ \clearpage
                \pdfpagewidth = 594mm \paperwidth = \pdfpagewidth
                \pdfpageheight = 420mm \paperheight = \pdfpageheight
                \textwidth = \dimexpr \pdfpagewidth - \Gm@lmargin - \Gm@rmargin
                \hsize=\textwidth
                \linewidth=\hsize
                \columnwidth=\hsize
                \def\x@offset{38.4}
                \def\y@offset{12.3}
                \designhm}
\@namedef{paper@A2p}{\clearpage
                \pdfpagewidth = 420mm \paperwidth = \pdfpagewidth
                \pdfpageheight = 594mm \paperheight = \pdfpageheight
                \textwidth = \dimexpr \pdfpagewidth - \Gm@lmargin - \Gm@rmargin
                \hsize=\textwidth
                \linewidth=\hsize
                \columnwidth=\hsize
                \def\x@offset{21.0}
                \def\y@offset{29.7}
                \designvm}
\@namedef{paper@A1}{ \clearpage
                \pdfpagewidth = 841mm \paperwidth = \pdfpagewidth
                \pdfpageheight = 594mm \paperheight = \pdfpageheight
                \textwidth = \dimexpr \pdfpagewidth - \Gm@lmargin - \Gm@rmargin
                \hsize=\textwidth
                \linewidth=\hsize
                \columnwidth=\hsize
                \def\x@offset{63.1}
                \def\y@offset{25.2}
                \designhm}
\@namedef{paper@A1p}{\clearpage
                \pdfpagewidth = 594mm \paperwidth = \pdfpagewidth
                \pdfpageheight = 841mm \paperheight = \pdfpageheight
                \textwidth = \dimexpr \pdfpagewidth - \Gm@lmargin - \Gm@rmargin
                \hsize=\textwidth
                \linewidth=\hsize
                \columnwidth=\hsize
                \def\x@offset{38.4}
                \def\y@offset{54.4}
                \designvm}
\@namedef{paper@A0}{ \clearpage
                \pdfpagewidth = 1189mm \paperwidth = \pdfpagewidth
                \pdfpageheight = 841mm \paperheight = \pdfpageheight
                \textwidth = \dimexpr \pdfpagewidth - \Gm@lmargin - \Gm@rmargin
                \hsize=\textwidth
                \linewidth=\hsize
                \columnwidth=\hsize
                \def\x@offset{97.9}
                \def\y@offset{54.4}
                \designhm}
\@namedef{paper@A0p}{\clearpage
                \pdfpagewidth = 841mm \paperwidth = \pdfpagewidth
                \pdfpageheight = 1189mm \paperheight = \pdfpageheight
                \textwidth = \dimexpr \pdfpagewidth - \Gm@lmargin - \Gm@rmargin
                \hsize=\textwidth
                \linewidth=\hsize
                \columnwidth=\hsize
                \def\x@offset{63.1}
                \def\y@offset{89.2}
                \designvm}
\def\paper#1{\expandafter\ifx\csname paper@#1\endcsname\relax
\expandafter\@gobble\else
\csname paper@#1\expandafter\endcsname
\fi}


%\newif\ifdrw@environment
%\newif\ifelt@environment

\newif\ifdrw@firstbackground% for drawing first page needs
\newif\ifelt@firstbackground% for element list first page needs
\newif\if@txtapx
\newif\if@drwapx
\newif\if@eltapx
\newif\ifapx@environment
\newcommand\istxtapx{\@txtapxtrue\@drwapxfalse\@eltapxfalse\apx@environmentfalse}
\newcommand\isdrwapx{\@drwapxtrue\@eltapxfalse\@txtapxfalse\apx@environmenttrue}
\newcommand\iseltapx{\@eltapxtrue\@drwapxfalse\@txtapxfalse\apx@environmenttrue}

\newcommand\drw@background% make drawing background
  {\ifdrw@firstbackground
     \form{1}\global\drw@firstbackgroundfalse
   \else
     \form{2a}
   \fi}

\newcommand\elt@background% make element list background
  {\ifelt@firstbackground
     \sheet{first}\global\elt@firstbackgroundfalse
   \else
     \sheet{after}
   \fi
  }

\newenvironment{drawing}[1][A3]%\paper{3} as default value for #1
 {\isdrwapx
  \newgeometry{top=0.5cm,bottom=1cm,right=1cm,left=2.5cm,layoutvoffset=0.5cm}
  \pagestyle{empty}
  \ClearShipoutPicture% Just in case there are any leftovers
  %\apx@environmenttrue
  \drw@firstbackgroundtrue
  \refstepcounter{tcnt}
  \setcounter{fcnt}{\thepage}
  %\clearpage
  \AddToShipoutPicture{\drw@background}
  \paper{#1}
 }
 {
  \paper{A4}
  \refstepcounter{tcnt}%
  \pagestyle{plain}%
  %\setcounter{apxtcnt}{\value{page}-\value{apxfcnt}+1}
  \ClearShipoutPicture
  \istxtapx
  %\apx@environmentfalse
  \clearpage
  \aftergroup\restoregeometry
 }

\newcommand\chart[1]{%
  \begin{textblock}{1}(0,0)%
   \setlength\parindent{0pt}
   \includegraphics[width=1.0\pdfpagewidth,height=1.0\pdfpageheight]{#1}
  \end{textblock}%
  \null\newpage
}



\newenvironment{elementlist}%[1]
  {\iseltapx
   %#1
   \newgeometry{margin=2cm,right=1cm}\pagestyle{empty}%
   \ClearShipoutPicture % Just in case there are any leftovers
   %\apx@environmenttrue
   \elt@firstbackgroundtrue
   \refstepcounter{tcnt}
   \setcounter{fcnt}{\thepage}
   \clearpage
   \AddToShipoutPicture{\elt@background}%
   \linespread{1.34}\selectfont
   \enlargethispage{-3\baselineskip}%
   \gostfnt
   \begin{longtable}[c]{@{}p{19mm}@{\hspace{2mm}}p{108mm}@{\hspace{2mm}}p{8mm}@{\hspace{2mm}}p{43mm}@{\hspace{1mm}}@{}}
  }%
  {\end{longtable}%
   %\setcounter{apxtcnt}{\value{page}-\value{apxfcnt}+1}
   \clearpage%
   \refstepcounter{tcnt}%
   \ClearShipoutPicture
   \pagestyle{plain}%
   \istxtapx
   %\apx@environmentfalse
   \restoregeometry
  }


\renewcommand{\@biblabel}[1]{#1.}

\renewenvironment{thebibliography}[1]
     {\chapter*{\bibname\@mkboth%
     {\bibname}{\bibname}}
      \list{\@biblabel{\@arabic\c@enumiv}}%
           {\settowidth\labelwidth{\@biblabel{#1}}%
            \leftmargin\labelwidth
            \advance\leftmargin \labelsep\itemsep=0pt\parsep=0pt\relax
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{\@arabic\c@enumiv}}%
      \sloppy
      \clubpenalty4000
      \@clubpenalty \clubpenalty
      \widowpenalty4000%
      \sfcode`\.\@m}
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist}


%floats top and bottom skips for correct placement
\setlength{\@fptop}{0pt}
\setlength{\@fpbot}{0pt plus 1fil}


%\setlength\abovecaptionskip{20\p@}
%\setlength\belowcaptionskip{10\p@}
\setlength{\abovecaptionskip}{10\p@ plus 2\p@ minus 5\p@}
\setlength{\belowcaptionskip}{10\p@ plus 2\p@ minus 5\p@}
\setlength{\intextsep}{15\p@ plus 2\p@ minus 5\p@}
\setlength{\textfloatsep}{15\p@ plus 2\p@ minus 5\p@} 

\long\def\@makecaption#1#2{%
  \vskip\abovecaptionskip
  \sbox\@tempboxa{#1~--~#2}%
  \def\@tempa{figure}
  \ifx\@captype\@tempa
    \addtocounter{figures}{1}
    \centering
    #1~--~#2
    \vskip\belowcaptionskip
  \else
    \addtocounter{tables}{1}
    \raggedright
    \setlength{\parindent}{2.5em} 
    #1~--~#2\par
    \vskip 10\p@
  \fi
}

\def\caption{%
   \ifx\@captype\@undefined
     \@latex@error{\noexpand\caption outside float}\@ehd
     \expandafter\@gobble
   \else
     \refstepcounter\@captype
     \expandafter\@firstofone
   \fi
   {\@dblarg{\@caption\@captype}}%
}

\long\def\@caption#1[#2]#3{%
  \par
  \addcontentsline{\csname ext@#1\endcsname}{#1}%
    {\protect\numberline{\csname the#1\endcsname}{\ignorespaces #2}}%
  \begingroup
    %\@parboxrestore
    \if@minipage
      \@setminipage
    \fi
    %\normalsize
    \@makecaption{\csname fnum@#1\endcsname}{\ignorespaces #3}\par
  \endgroup}


%\long\def\@makecaption#1#2{%
%  \vskip\abovecaptionskip
%  \onespace
%  \ifx\@captype\capfigure
%      \centering #1~--~#2 \par
%  \else
%      #1~--~#2 \par
%  \fi
%  \vskip\belowcaptionskip}

%\long\def\@makecaption#1#2{%
%  \vskip\abovecaptionskip
%  \sbox\@tempboxa{#1~--~#2}%
%  \ifx\@captype\capfigure
%    \centering #1~--~#2 \par
%  \else
%  %  \ifdim \wd\@tempboxa >\hsize
%      #1~--~#2\par
%  %  \else
%  %    \global \@minipagefalse
%  %    \hb@xt@\hsize{\hfil\box\@tempboxa\hfil}%
%  %  \fi
%  \fi
%  \vskip\belowcaptionskip}


\newcommand\n{\protect\\}

\newcommand\emp{}
\newcommand\male{male}
\newcommand\female{female}


\renewcommand\maketitle{
\frontmatter
\onespace
\thispagestyle{empty}%
\newgeometry{top=15mm, bottom=25mm, right=20mm, left=30mm}%
\begin{titlepage}
  \centering{\@educational\\*Факультет \@faculty\\*Кафедра \@department\\*}
  \vfill
  \vfill
  \centering{\large\textbf{\@typeofwork~на~тему:}}\par
  \centering{<<\textsc{\@title}>>}\par 
  \vfill
  \vfill
  \hfill\begin{minipage}{0.62\textwidth}\raggedright
  Виконав: \uline{студент%
  \hfill~\@course~\hfill курсу, групи \hfill \@group}\par
  %спеціальності~\expandafter\lul\expandafter{\@speciality}\uline{\hfill}\par
  спеціальності~\expandafter\longunderline\expandafter{\@speciality}\par
  \centering{\footnotesize(шифр і назва спеціальності)}\par
  \vspace{1.0em}
  \noindent
  %\uline{\@author\hfill}\par
  \expandafter\longunderline\expandafter{\@author}\par
  \centering{\footnotesize(прізвище та ініціали)}\par
  \vspace{1.0em}
  
  Керівник: \ifx\@degree\emp~\uline{\@position~каф.~\@departmentabbr\hfill}\par
            \else \uline{\@degree, \@position~каф.~\@departmentabbr\hfill}\par
            \fi
  
  %\uline{\@leader \hfill}\par
  \expandafter\longunderline\expandafter{\@leader}\par
  \centering{\footnotesize(прізвище та ініціали)}\par
  <<\uline{\mbox{\hspace*{3em}}}>>~\uline{\hfill}~\@annum~р.\par
  \vspace{1.0em}
  \noindent
  Рецензент: \ifx\@rdegree\emp~\uline{\@rposition~каф.~\@rdepartmentabbr\hfill}\par
             \else \uline{\@rdegree, \@rposition~каф.~\@rdepartmentabbr\hfill}\par
             \fi
  \uline{\@reviewer\hfill}\par
  \centering{\footnotesize(прізвище та ініціали)}\par
  <<\uline{\hspace*{3em}}>>~\uline{\hfill}~\@annum~р.\par
  \end{minipage}
  \vfill
  \vfill
  \noindent%
  {\begin{minipage}{0.4\textwidth}
    Допущено до захисту\par
    \@dpheaderstatus~\@departmentabbr\par
    \uline{\hfill}\par
    <<\uline{\hspace*{3em}}>>~\uline{\hfill}~\@annum~р.\par
  \end{minipage}\hfill}
  \vfill 
  \centering{\@city~\@educationalabbr~--~{\@annum}~рік\\}
\end{titlepage}
\restoregeometry
\oneandhalfspace
\mainmatter}


%inveronment `assignment` for bdr assignment typesetting. 
\newenvironment{assignment}[8]{%environment `assignment` header 
  \frontmatter%
  \onespace%
  \thispagestyle{empty}%
  %\newgeometry{left=3.0cm, top=1.0cm, right=1.0cm, bottom=1.0cm}%
  \newgeometry{inner=3.0cm, top=1.0cm, outer=1.0cm, bottom=1.0cm, twoside}%
  \setcounter{page}{3}%
  
    {\centering\@educational\par}
    \vspace{1.0em}
    \noindent Факультет \expandafter\longunderline\expandafter{\@faculty}\par%
    \noindent Кафедра \expandafter\longunderline\expandafter{\@department}\par%
    \noindent Рівень~вищої~освіти~\longunderline{перший~(бакалаврський)}\par%
    \noindent Галузь~знань~\expandafter\longunderline\expandafter{\@branchofknowledge}\par%                                                    
    \noindent Спеціальність~\expandafter\longunderline\expandafter{\@speciality}\par%
    \noindent Освітньо-професійна~програма~\expandafter\longunderline\expandafter{\@educationalprogram}\par%
    \vspace{1.0em}
   
    {\hfill%
    \begin{minipage}{0.5\textwidth}\centering
    \textsc{\textbf{затверджую}}\par
    \@dpheaderstatus~\@departmentabbr\par
    \uline{\hfill}~д.т.н.,~проф.~\@approver\par
    <<\uline{\hspace*{3em}}>>~\uline{\hfill}~\@annum~р.\par 
    \end{minipage}}
    \vspace{1.0em} 
 
    {\centering\textbf{ЗАВДАННЯ}\par}
    {\centering\textsc{на \@acstypeofwork}\par}
    \vspace{1.0em}

    {\noindent\uline{\hfill\@gcauthor\hfill}\par
    \hfill\footnotesize{(прізвище,~ім'я,~по батькові)}\hfill}
    \vspace{1.0em}
  
  %1
  \noindent 1. Тема роботи: \expandafter\longunderline\expandafter{\@title}\par		
  \noindent керівник роботи: \expandafter\ul\expandafter{\@leader}%
  \ifx\@degree\emp \ul{,~}\expandafter\ul\expandafter{\@position}\par%
  \else \ul{,~}\expandafter\ul\expandafter{\@degree}\ul{,~}\expandafter\longunderline\expandafter{\@position}\par
  \fi
  \noindent затверджені наказом вищого навчального закладу від \longunderline{#1}\par\vspace{1ex}

  %2
  \noindent 2. Строк подання студентом роботи \longunderline{#2}\par\vspace{1ex}

  %3
  \noindent 3. Вихідні дані до роботи:\par #3\par\vspace{1ex}

  %4
  %\noindent 4. Зміст розрахунково-пояснювальної записки (перелік питань, які потрібно розробити). \lul{#4}\par\vspace{1ex}
  \noindent 4. Зміст розрахунково-пояснювальної записки (перелік питань, які потрібно розробити). \longunderline{#4}\par\vspace{1ex}
 
  %5
  %\noindent 5. Перелік графічного матеріалу (з точним зазначенням обов’язкових креслень). \lul{#5}\par\vspace{1ex}
  \noindent 5. Перелік графічного матеріалу (з точним зазначенням обов’язкових креслень). \longunderline{#5}\par\vspace{1ex}
  
  \newpage

  %6
  \noindent 6. Консультанти розділів роботи \par
  \noindent% 
  \begin{tabular}{|c|p{10.1cm}|c|c|}\hline%
  \multirow{3}{*}{Розділ}% 
  & \multirow{3}{*}{\begin{tabular}[c]{@{}l@{}}Прізвище, ініціали та посада  \\консультанта\end{tabular}}% 
  & \multicolumn{2}{c|}{Підпис, дата} \\ \cline{3-4}%
  & & завдання & завдання \\%
  & & видав    & прийняв  \\% 
  \hline\hline%
  #6
  \end{tabular}%
  \par\vspace{2ex}%

  %7
  \noindent 7. Дата видачі завдання \longunderline{#7}\par\vspace{2ex}
  
  %8 
  \centering{\textbf{КАЛЕНДАРНИЙ ПЛАН}}\par\vspace{2ex}
  \noindent%
  \raggedright%
  \begin{tabular}{|c|m{7.7cm}|c|c|c|}% 
  \hline%
  \multirow{2}{*}{\begin{tabular}[c]{@{}c@{}}№ \\з/п \end{tabular}}% 
  & \multirow{2}{*}{\begin{tabular}[c]{@{}l@{}}Назва етапів бакалаврської  \\дипломної роботи \end{tabular}}% 
  & \multicolumn{2}{c|}{Термін виконання}% 
  & \multirow{2}{*}{\begin{tabular}[c]{@{}l@{}}Примітка\\ \end{tabular}} \\% 
  \cline{3-4} &  & початок & закінчення & ~ \\% 
  \hline\hline%
  #8
  \end{tabular}% 
  \par%

  %signs
  %{\vspace{4ex}\raggedleft
  %Студент~\uline{\hspace{20ex}}~\@author\par
  %\vspace{2ex}
  %Керівник роботи~\uline{\hspace{20ex}}~\@leader\par}

{\vspace{5ex}\noindent Студент\hfill~\underline{\makebox[3cm]{\vphantom{\@author}}}~\underline{\makebox[5cm]{\@author}}\par}
{\noindent \hfill~{\makebox[3cm]{\footnotesize(підпис)}}~{\makebox[5cm]{\footnotesize(прізвище, ініціали)}}\par\vspace{3.0ex}}

{Керівник роботи\hfill~\underline{\makebox[3cm]{\vphantom{\@leader}}}~\underline{\makebox[5cm]{\@leader}}\par}
{\noindent \hfill~{\makebox[3cm]{\footnotesize(підпис)}}~{\makebox[5cm]{\footnotesize(прізвище, ініціали)}}\par}
  
}%environment `assignment` header
{%environment `assignment` footer
  \thispagestyle{empty}%
  \restoregeometry%
  \mainmatter%
}%environment `assignment` footer

%
\newcommand{\consultant}[2]{#1 & #2 &  & \rule[-1em]{0pt}{2.6em} \\ \hline}%
\newcommand{\stage}[4]{#1 & #2 & #3 & #4 & \\ \hline}%






\newenvironment{noindentlist}{%
  \begin{list}{}{\setlength{\parsep}{0pt}%
  \setlength{\topsep}{0pt}%
  \setlength{\itemsep}{5pt}%
  \setlength{\labelsep}{5pt}%
  \setlength{\labelwidth}{4em}%
  \setlength{\leftmargin}{15pt}%
  \addtolength{\leftmargin}{0pt}}}{%
  \end{list}}

\newcommand{\protocol}[2]{
{\centering{ПРОТОКОЛ\\ ПЕРЕВІРКИ ДИПЛОМНОЇ РОБОТИ\\ НА НАЯВНІСТЬ ТЕКСТОВИХ ЗАПОЗИЧЕНЬ}\par\vspace{3.0ex}}

\noindent Назва роботи: \expandafter\longunderline\expandafter{\@title}\par\vspace{1.0ex}

\noindent Тип роботи: \uline{\@typeofwork\hfill}\par
{\centering{\footnotesize(БДР, МКР)}\par\vspace{1.0ex}}

\noindent Підрозділ: \uline{\@departmentabbr,~Ф\@facultyabbr,~\@group\hfill}\par
{\centering{\footnotesize(кафедра, факультет, навчальна група)}\par\vspace{1.0ex}}

\noindent Керівник: \ifx\@degree\emp~\uline{\@leader~\@position~каф.~\@departmentabbr\hfill}\par
            \else \uline{\@leader~\@degree,~\@position~каф.~\@departmentabbr\hfill}\par
            \fi
{\centering{\footnotesize(прізвище, ініціали, посада)}\par\vspace{2.0ex}}

{\centering\textbf{Показники звіту подібності Unicheck}\par\vspace{1.0ex}}

\noindent Оригінальність~\underline{\makebox[5cm]{#1}}\makebox[1cm]{}Схожість~\underline{\makebox[5cm]{#2}}\par\vspace{1.0ex} 

\noindent Аналіз звіту подібності (відмітити потрібне)


\begin{noindentlist}
 \item[$\blacksquare$] {\footnotesizeЗапозичення, виявлені у роботі оформлені коректно і не містять ознак плагіату}
 \item[$\square$] {\footnotesizeВиявлені у роботі запозичення не мають ознак плагіату, але їх надмірна кількість викли-кає сумніви щодо цінності роботи і відсутності самостійності її автора. Роботу направити на розгляд експертної комісії кафедри}
 \item[$\square$] {\footnotesizeВиявлені у роботі запозичення є недобросовісними і мають ознаки плагіату та/або в ній містяться навмисні спотворення тексту, що вказують на спроби приховування недобро-совісних запозичень} 
\end{noindentlist}\vspace{2.0ex}

{\noindent Особа, відповідальна за перевірку\hfill~\underline{\makebox[3cm]{\vphantom{\@controller}}}~\underline{\makebox[5cm]{\@controller}}\par}
{\noindent \hfill~{\makebox[3cm]{\footnotesize(підпис)}}~{\makebox[5cm]{\footnotesize(прізвище, ініціали)}}\par\vspace{2.0ex}}

\noindent Ознайомлені з повним звітом подібності, який був згенерований системою Unicheck щодо роботи\vspace{2.0ex}

{\noindent Автор\hfill~\underline{\makebox[3cm]{\vphantom{\@author}}}~\underline{\makebox[5cm]{\@author}}\par}
{\noindent \hfill~{\makebox[3cm]{\footnotesize(підпис)}}~{\makebox[5cm]{\footnotesize(прізвище, ініціали)}}\par\vspace{3.0ex}}

{\noindent Керівник роботи\hfill~\underline{\makebox[3cm]{\vphantom{\@leader}}}~\underline{\makebox[5cm]{\@leader}}\par}
{\noindent \hfill~{\makebox[3cm]{\footnotesize(підпис)}}~{\makebox[5cm]{\footnotesize(прізвище, ініціали)}}\par}
}



\renewcommand\tableofcontents{%
    \frontmatter%
    \chapter*{\contentsname}%
    \mainmatter%
    \@starttoc{toc}%
}

\def\@starttoc#1{%
  \begingroup
  \if@latexmark
    \enlargethispage{-2\baselineskip}
    \renewcommand{\@evenfoot}{\hfill\small Typeset by \LaTeX}
    \renewcommand{\@oddfoot}{\hfill\small Typeset by \LaTeX}
  \fi
    \makeatletter
    \@input{\jobname.#1}%
    \if@filesw
      \expandafter\newwrite\csname tf@#1\endcsname
      \immediate\openout \csname tf@#1\endcsname \jobname.#1\relax
    \fi
    \@nobreakfalse
  \endgroup
}




%-------------------------------------------------------------------------------------------------------------
%%%% \chapter redefinition -----------------------------------------------------------------------------------
%%%% make common chapter command -----------------------------------------------------------------------------
\renewcommand\chapter{\if@eltapx% if element list appendix do not typeset chapter header
                      \else
                        \clearpage%
                        \global\@topnum\z@%
                        \@afterindenttrue%
                      \fi
                      \secdef\@chapter\@schapter}


%%%% \@chapter redefinition ----------------------------------------------------------------------------------
%%%% no asterisk chapter command source ----------------------------------------------------------------------
\def\@chapter[#1]#2{%
   \ifnum\c@secnumdepth>\m@ne%
     \if@mainmatter%                 
       \refstepcounter{chapter}%
       \addcontentsline{toc}{chapter}{\protect\numberline{\thechapter}\texorpdfstring{\MakeUppercase{#1}}{#1}}%
     \else%
       \refstepcounter{chapter}%
       \phantomsection%
       \addcontentsline{toc}{appendix}{\texorpdfstring{\@chapapp\space\protect\numberline\thechapter#1}{\@chapapp\space\thechapter\space#1}}%
     \fi%
   \else%
     \addcontentsline{toc}{chapter}{#1}%
   \fi%
     \chaptermark{#1}%
     \addtocontents{lof}{\protect\addvspace{10\p@}}%
     \addtocontents{lot}{\protect\addvspace{10\p@}}%
     \if@eltapx%
       \element{}{}{}{\centering\@chapapp\space\thechapter}
%       \category{#1}
     \else
       \@makechapterhead{#2}%
       \@afterheading
     \fi}


%%%% \@schapter redefinition ---------------------------------------------------------------------------------
%%%% asterisk chapter command source -------------------------------------------------------------------------
\def\@schapter#1{%
   \if@mainmatter
     \phantomsection 
     \addcontentsline{toc}{chapter}{\texorpdfstring{\MakeUppercase{#1}}{#1}}
   \fi
     \@makeschapterhead{#1}
     \@afterheading}


%%%% variant with regular dots in TOC
%%%% \l@chapter redefinition ---------------------------------------------------------------------------------
%%%% command which handle chapter entry in TOC ---------------------------------------------------------------
\renewcommand\l@chapter[2]{%
   \ifnum \c@tocdepth >\m@ne
     \vskip \z@ \@plus.2\p@
     {\leftskip 0.0em\relax \rightskip \@tocrmarg plus 15em \parfillskip -\rightskip%mod <plus 15em> for avoid hyph. in TOC
      \parindent 0.0em\relax\@afterindenttrue
      \interlinepenalty\@M
      \leavevmode
      \@tempdima 1.2em\relax
      \advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip
      {#1}\nobreak
      \leaders\hbox to .7em{\hss.\hss}\hfill
      \nobreak
      \hb@xt@\@pnumwidth{\hfil \normalcolor #2}%   \hfil\normalfont   |||
      \par}%
   \fi}


%%%% old variant 
%%%% \l@chapter redefinition ---------------------------------------------------------------------------------
%\renewcommand\l@chapter[2]{%
%  \ifnum \c@tocdepth >\m@ne
%    \addpenalty{-\@highpenalty}%
%  \vskip 0.0em \@plus\p@
%    \setlength\@tempdima{1.0em}%
%    \begingroup
%      \parindent \z@ \rightskip \@pnumwidth plus 15em %mod <plus 15em> for avoid hyph. in TOC
%      \parfillskip -\@pnumwidth
%   \leavevmode\hangindent=1.0em
%   %\advance\leftskip\@tempdima 
%   %\hskip -\leftskip
%      #1 \nobreak 
%          \xleaders\hbox{$\m@th% \cleaders or \leaders may use for better alignment
%          \mkern \@dotsep mu\hbox{.}\mkern\@dotsep
%         mu$}\hfill%
% \hbox to\@pnumwidth{\hss #2}\par 
%        %\nobreak\hb@xt@\@pnumwidth{\hss #2}\par
%      \penalty\@highpenalty
%    \endgroup
%  \fi}


%%%% variant with regular dots in TOC
%%%% \l@appendix definition -----------------------------------------------------------------------------------
%%%% command which handle appendix entry in TOC ---------------------------------------------------------------
\newcommand\l@appendix[2]{%
   \ifnum \c@tocdepth >\m@ne
     \vskip \z@ \@plus.2\p@
     {\leftskip 0.0em\relax \rightskip \@tocrmarg plus 15em \parfillskip -\rightskip%mod <plus 15em> for avoid hyph. in TOC
      \parindent 0.0em\relax \hangindent 4.2em\relax\@afterindenttrue
      \interlinepenalty\@M
      \leavevmode
      \@tempdima 1.5em\relax
      \advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip
      {#1}\nobreak
      %\leaders\hbox{$\m@th \mkern \@dotsep mu\hbox{.}\mkern \@dotsep mu$}\hfill
      \leaders\hbox to .7em{\hss.\hss}\hfill
      \nobreak
      \hb@xt@\@pnumwidth{\hfil \normalcolor #2}%   \hfil\normalfont   |||
      \par}%
   \fi}

%%%% old variant
%%%% \l@appendix definition -----------------------------------------------------------------------------------
%\newcommand\l@appendix[2]{%
%  \ifnum \c@tocdepth >\m@ne
%    \addpenalty{-\@highpenalty}%
%  \vskip 0.0em \@plus\p@
%    \setlength\@tempdima{1.5em}%
%    \begingroup
%      \parindent \z@ \rightskip \@pnumwidth plus 15em %mod <plus 15em> for avoid hyph. in TOC
%      \parfillskip -\@pnumwidth
%      \leavevmode\hangindent=5.9em
%   %\advance\leftskip\@tempdima 
%   %\hskip -\leftskip
%      {#1}\nobreak
%          \leaders\hbox{$\m@th
%          \mkern \@dotsep mu\hbox{.}\mkern \@dotsep
%         mu$}\hfill% 
%        %\nobreak\hb@xt@\@pnumwidth{\hss #2}\par
% %\hbox to\@pnumwidth{\hss #2}\par
%\hb@xt@\@pnumwidth{\hfil \normalcolor #2}\par%   
%      %\penalty\@highpenalty
%    \endgroup
%  \fi}


%%%% \@makechapterhead redefinition ---------------------------------------------------------------------------
%%%% command which handle `no asterisk` chapter appearing in main text ----------------------------------------
\def\@makechapterhead#1{%
  \if@mainmatter{%main part of work
    \parindent \z@ \centering \normalfont
    \ifnum \c@secnumdepth >\m@ne
      \thechapter\hspace{1.0ex}
    \fi
      \interlinepenalty\@M
      \MakeUppercase{#1}\par\nobreak
      \vskip 30\p@}
  \else%appendix part of work
  \if@drwapx{%if appendix is drawing
      \parindent \z@ \centering \normalfont
      \ifnum \c@secnumdepth >\m@ne
        \gostfnt{\@chapapp\space\thechapter\hspace{2cm}\nobreak} 
      \fi
        \interlinepenalty\@M
        {#1}\par\nobreak
        \vskip 30\p@}
  \fi%end drawing appendix chapter
  \if@txtapx{%if appendix is text 
      \parindent \z@ \centering% \normalfont
      \ifnum \c@secnumdepth >\m@ne
        \@chapapp\space 
        \thechapter\space\par\nobreak 
        \nobreak 
      \fi
        \interlinepenalty\@M
        {#1}\par\nobreak
        \vskip 30\p@}
  \fi%end text appendix chapter
        %\if@eltapx % if elementlist appendix 
          %\category{\@chapapp\space\thechapter}
          %do nothing
        %\fi
  \fi}%else fi  
  

%%%% \@makeschapterhead redefinition --------------------------------------------------------------------------
%%%% command which handle `asterisk` chapter appearing in main text -------------------------------------------
\def\@makeschapterhead#1{%
  %\vspace*{50\p@}%
  {\parindent \z@ \centering %\normalfont
    \interlinepenalty \@M
    \MakeUppercase{#1} \par\nobreak
    %\vskip 20\p@
    \vskip 30\p@}}



\def\@startsection#1#2#3#4#5#6{
                  \if@noskipsec 
                    \leavevmode 
                  \fi \par 
                  \@tempskipa #4\relax
                  \@afterindenttrue 
                  %\ifdim \@tempskipa <\z@ 
                  %  \@tempskipa -\@tempskipa \@afterindentfalse 
                  %\fi
                  \if@nobreak 
                    \everypar {}
                  \else
                    \addpenalty \@secpenalty \addvspace \@tempskipa 
                  \fi
                  \@ifstar {\@ssect {#3}{#4}{#5}{#6}}
                  {\@dblarg {\@sect {#1}{#2}{#3}{#4}{#5}{#6}}}}


\def\@sect#1#2#3#4#5#6[#7]#8{%
  \rightskip \z@ plus 15em             %avoid hyphenation in section name
  \ifnum #2>\c@secnumdepth
    \let\@svsec\@empty
  \else
    \refstepcounter{#1}%
    \protected@edef\@svsec{\@seccntformat{#1}\relax}%
  \fi
  \@tempskipa #5\relax
  \ifdim \@tempskipa>\z@
    \begingroup
      #6{%
        \@hangfrom{\hskip #3\relax\@svsec}%
          %\interlinepenalty \@M #8\@@par}%
          \interlinepenalty \@M #8}%          %
    \endgroup
    \csname #1mark\endcsname{#7}%
    \addcontentsline{toc}{#1}{%
      \ifnum #2>\c@secnumdepth \else
        \protect\numberline{\csname the#1\endcsname}%
      \fi
      #7}%
  \else
    \def\@svsechd{%
      #6{\hskip #3\relax
      \@svsec #8}%
      \csname #1mark\endcsname{#7}%
      \addcontentsline{toc}{#1}{%
        \ifnum #2>\c@secnumdepth \else
          \protect\numberline{\csname the#1\endcsname}%
        \fi
        #7}}%
  \fi
  \@xsect{#5}
  \rightskip\z@}                    %cancel avoid hyphenation in section name

\def\@xsect#1{%
  \@tempskipa #1\relax
  \ifdim \@tempskipa>\z@
    \par \nobreak
    \vskip \@tempskipa
    \@afterheading
  \else
    \@nobreakfalse
    \global\@noskipsectrue
    \everypar{%
      \if@noskipsec
        \global\@noskipsecfalse
       {\setbox\z@\lastbox}%
        \clubpenalty\@M
        \begingroup \@svsechd \endgroup
        \unskip
        \@tempskipa #1\relax
        \hskip -\@tempskipa
      \else
        \clubpenalty \@clubpenalty
        \everypar{}%
      \fi}%
  \fi
  \ignorespaces}

%redefinition \section command (http://latexref.xyz/bs-at-startsection.html)
\renewcommand\section{%
  \@startsection{section}%name
                {1}%level
                {\parindent}%indent
                {6.5ex \@plus 1ex \@minus .2ex}%beforeskip
                %{3.5ex \@plus 1ex \@minus .2ex}%beforeskip
                {4.5ex \@plus .2ex}%afterskip
                %{3.5ex \@plus .2ex}%afterskip
                {}}%style

\renewcommand\subsection{%
  \@startsection{subsection}%name
                {2}%level
                {\parindent}%indent
                {6.5ex \@plus 1ex \@minus .2ex}%beforeskip
                %{3.5ex \@plus 1ex \@minus .2ex}%beforeskip
                {4.5ex \@plus .2ex}%afterskip
                %{3.5ex \@plus .2ex}%afterskip
                {}}%style

\renewcommand*\l@section[2]{\ifnum \c@tocdepth >\m@ne
    \vskip \z@ \@plus.2\p@
    {\leftskip 0.0em\relax \rightskip \@tocrmarg plus 15em \parfillskip -\rightskip%mod <plus 15em> for avoid hyph. in TOC
     \parindent 1.3em\relax\hangindent 1.4em\relax\@afterindenttrue
     \interlinepenalty\@M
     \leavevmode
     \@tempdima 2.0em\relax
     \advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip
     {#1}\nobreak
     %\leaders\hbox{$\m@th \mkern \@dotsep mu\hbox{.}\mkern \@dotsep mu$}\hfill
     \leaders\hbox to .7em{\hss.\hss}\hfill
     \nobreak
     \hb@xt@\@pnumwidth{\hfil \normalcolor #2}%   \hfil\normalfont   |||
     \par}%
  \fi}

\renewcommand*\l@subsection[2]{\ifnum \c@tocdepth >\m@ne
    \vskip \z@ \@plus.2\p@
    {\leftskip 0.0em\relax \rightskip \@tocrmarg plus 15em \parfillskip -\rightskip%mod <plus 15em> for avoid hyph. in TOC
     \parindent 3.4em\relax\hangindent 3.5em\relax\@afterindenttrue
     \interlinepenalty\@M
     \leavevmode
     \@tempdima 2.6em\relax
     \advance\leftskip \@tempdima \null\nobreak\hskip -\leftskip
     {#1}\nobreak
     %\leaders\hbox{$\m@th \mkern \@dotsep mu\hbox{.}\mkern \@dotsep mu$}\hfill
     \leaders\hbox to .7em{\hss.\hss}\hfill
     \nobreak
     \hb@xt@\@pnumwidth{\hfil \normalcolor #2}%   \hfil\normalfont   |||
     \par}%
  \fi}


\renewcommand{\appendix}{\@ifstar{\@appendixstarred}{\@appendixunstarred}}
\newcommand{\@appendixstarred}{
  \par%
  \aftermatter%
  \istxtapx%
  \setcounter{chapter}{0}%
  \setcounter{section}{0}%
  \gdef\@chapapp{\appendixname}%
  \gdef\thechapter{\@Abetka\c@chapter}}
\newcommand{\@appendixunstarred}{
  \newpage~\par%
  \phantomsection%
  \addcontentsline{toc}{appendix}{\appendixtitle}
  \vfill\begin{center}\appendixtitle\vfill\end{center}
  \newpage 
  \aftermatter%
  \istxtapx%
  \setcounter{chapter}{0}%
  \setcounter{section}{0}%
  \gdef\@chapapp{\appendixname}%
  \gdef\thechapter{\@Abetka\c@chapter}}

\providecommand*{\toclevel@appendix}{0}%

%\renewcommand\appendix{\par%
%  \aftermatter%
%  \textappendix%
%  \setcounter{chapter}{0}%
%  \setcounter{section}{0}%
%  \gdef\@chapapp{\appendixname}%
%  \gdef\thechapter{\@Abetka\c@chapter}%
%}


%\renewcommand\appendix{\newpage~\par%
%  \phantomsection%
%  \addcontentsline{toc}{appendix}{\appendixtitle}
%  \vfill\begin{center}\appendixtitle\vfill\end{center}
%  \newpage 
%  \aftermatter%
%  \textappendix%
%  \setcounter{chapter}{0}%
%  \setcounter{section}{0}%
%  \gdef\@chapapp{\appendixname}%
%  \gdef\thechapter{\@Abetka\c@chapter}%
%}




\newcommand\explmark[1]{\renewcommand\@explmark{#1}}
\newcommand\@explmark{{де }}

\newlength{\explanwidth}
%\settowidth{\explanwidth}{\@explmark}

\newcommand{\fitem}{\refstepcounter{enumi}\item[\@explmark]}

%\setlength{\explanwidth}{1.8em}
\newlength{\explanindent}\setlength{\explanindent}{0pt}
\newenvironment{explanation}{%
  \begin{list}{}{\setlength{\parsep}{0pt}%
  \setlength{\topsep}{0pt}%
  \setlength{\itemsep}{0pt}%
  \setlength{\labelsep}{0pt}%
  \settowidth{\explanwidth}{\@explmark}%
  \setlength{\labelwidth}{\explanwidth}%
  \setlength{\leftmargin}{\explanwidth}%
  \addtolength{\leftmargin}{\explanindent}}}{%
  \end{list}}


  